package com.bstek.ureport.cache;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import com.bstek.ureport.definition.ReportDefinition;

public class DefaultMemoryReportDefinitionCache implements ReportDefinitionCache {
	private Map<String,ReportDefinition> reportMap=new ConcurrentHashMap<String,ReportDefinition>();
	@Override
	public ReportDefinition getReportDefinition(String file) {
		return reportMap.get(file);
	}
	@Override
	public void cacheReportDefinition(String file,ReportDefinition reportDefinition) {
		if(reportMap.containsKey(file)){
			reportMap.remove(file);
		}
		reportMap.put(file, reportDefinition);
	}
}
