package com.hand.hls.web.svc.components;

import org.springframework.beans.BeansException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.core.io.Resource;
import org.springframework.stereotype.Component;

import java.io.IOException;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-12-14
 * Time: 17:54
 */
@Component
public class ScriptRunnerFactory implements ApplicationContextAware{
    @Autowired
    private BmOperation bmOperation;
    private String webPath;

    public ScriptRunner createRunner() {
        return new ScriptRunner(bmOperation, webPath);
    }

    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        Resource resource = applicationContext.getResource("/WEB-INF");
        if(resource == null||!resource.exists()){
            throw new RuntimeException("could not found path: /WEB-INF");
        }
        try {
            this.webPath = resource.getFile().getAbsolutePath();
        } catch (IOException e) {
            throw new RuntimeException("could not load path: /WEB-INF");
        }
    }
}


