package com.hand.hls.web.svc.utils;

import com.hand.hls.web.svc.domain.Field;
import org.apache.commons.lang3.StringUtils;
import org.springframework.util.Assert;

/**
 * Created with IntelliJ IDEA.
 * User: yang
 * Date: 2017-12-07
 * Time: 15:45
 */
public class FieldParser {
    public static String parseQueryField(Field field, String tableAlias) {
        String name = field.getName();
        if (StringUtils.isNotEmpty(tableAlias)) {
            name = tableAlias + "." + name;
        }
        Assert.notNull(name, "field must has a name");
        String alias = field.getAlias();
        if (StringUtils.isNotEmpty(alias)) {
            name = name + " as " + alias;
        }

        return name;
    }

    public static String parseSaveField(Field field) {
        Assert.notNull(field,"Field must be nonNull");
        String defaultValue = field.getDefaultValue();
        String name = field.getName();
        return name;
    }
}