package com.hls.core.sys.controllers;

import com.hand.hap.core.web.view.ui.Model;
import org.springframework.stereotype.Controller;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.core.IRequest;
import com.hand.hap.system.dto.ResponseData;
import com.hls.core.sys.dto.Layout;
import com.hls.core.sys.service.ILayoutService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import org.springframework.validation.BindingResult;
import org.springframework.web.servlet.ModelAndView;

import java.util.List;

    @Controller
    public class LayoutController extends BaseController{

    @Autowired
    private ILayoutService service;


    @RequestMapping(value = "/sys/layout/query")
    @ResponseBody
    public ResponseData query(Layout dto, @RequestParam(defaultValue = DEFAULT_PAGE) int page,
        @RequestParam(defaultValue = DEFAULT_PAGE_SIZE) int pageSize, HttpServletRequest request) {
        IRequest requestContext = createRequestContext(request);
        return new ResponseData(service.select(requestContext,dto,page,pageSize));
    }

    @RequestMapping(value = "/sys/layout/submit")
    @ResponseBody
    public ResponseData update(@RequestBody List<Layout> dto, BindingResult result, HttpServletRequest request){
        getValidator().validate(dto, result);
        if (result.hasErrors()) {
            ResponseData responseData = new ResponseData(false);
            responseData.setMessage(getErrorMessage(result, request));
            return responseData;
        }
        IRequest requestCtx = createRequestContext(request);
        return new ResponseData(service.batchUpdate(requestCtx, dto));
    }

    @RequestMapping(value = "/sys/layout/remove")
    @ResponseBody
    public ResponseData delete(HttpServletRequest request,@RequestBody List<Layout> dto){
        service.batchDelete(dto);
        return new ResponseData();
    }

    @RequestMapping(value = { "/form/{name}"})
    public ModelAndView renderView(@PathVariable String name, Model model) {
        return new ModelAndView(name+".form");
    }

    @RequestMapping(value = { "/form_preview"})
    public ModelAndView previewView(@RequestParam String code, Model model) {
        return new ModelAndView("preview/"+code+".form");
    }
}